

<!DOCTYPE html>
<!--[if IE 8]><html class="no-js lt-ie9" lang="en" > <![endif]-->
<!--[if gt IE 8]><!--> <html class="no-js" lang="en" > <!--<![endif]-->
<head>
  <meta charset="utf-8">
  
  <meta name="viewport" content="width=device-width, initial-scale=1.0">
  
  <title>d2o.utils package &mdash; d2o Python Library 1.0 documentation</title>
  

  
  

  

  
  
    

  

  
  
    <link rel="stylesheet" href="_static/css/theme.css" type="text/css" />
  

  

  
    <link rel="top" title="d2o Python Library 1.0 documentation" href="index.html"/> 

  
  <script src="_static/js/modernizr.min.js"></script>

</head>

<body class="wy-body-for-nav" role="document">

  <div class="wy-grid-for-nav">

    
    <nav data-toggle="wy-nav-shift" class="wy-nav-side">
      <div class="wy-side-scroll">
        <div class="wy-side-nav-search">
          

          
            <a href="index.html" class="icon icon-home"> d2o Python Library
          

          
          </a>

          
            
            
              <div class="version">
                1.0
              </div>
            
          

          
<div role="search">
  <form id="rtd-search-form" class="wy-form" action="search.html" method="get">
    <input type="text" name="q" placeholder="Search docs" />
    <input type="hidden" name="check_keywords" value="yes" />
    <input type="hidden" name="area" value="default" />
  </form>
</div>

          
        </div>

        <div class="wy-menu wy-menu-vertical" data-spy="affix" role="navigation" aria-label="main navigation">
          
            
            
                <ul class="simple">
</ul>

            
          
        </div>
      </div>
    </nav>

    <section data-toggle="wy-nav-shift" class="wy-nav-content-wrap">

      
      <nav class="wy-nav-top" role="navigation" aria-label="top navigation">
        <i data-toggle="wy-nav-top" class="fa fa-bars"></i>
        <a href="index.html">d2o Python Library</a>
      </nav>


      
      <div class="wy-nav-content">
        <div class="rst-content">
          

 



<div role="navigation" aria-label="breadcrumbs navigation">
  <ul class="wy-breadcrumbs">
    <li><a href="index.html">Docs</a> &raquo;</li>
      
    <li>d2o.utils package</li>
      <li class="wy-breadcrumbs-aside">
        
          
            <a href="_sources/d2o.utils.txt" rel="nofollow"> View page source</a>
          
        
      </li>
  </ul>
  <hr/>
</div>
          <div role="main" class="document" itemscope="itemscope" itemtype="http://schema.org/Article">
           <div itemprop="articleBody">
            
  <div class="section" id="d2o-utils-package">
<h1>d2o.utils package<a class="headerlink" href="#d2o-utils-package" title="Permalink to this headline">¶</a></h1>
<div class="section" id="submodules">
<h2>Submodules<a class="headerlink" href="#submodules" title="Permalink to this headline">¶</a></h2>
</div>
<div class="section" id="module-d2o.utils.calc">
<span id="d2o-utils-calc-module"></span><h2>d2o.utils.calc module<a class="headerlink" href="#module-d2o.utils.calc" title="Permalink to this headline">¶</a></h2>
<dl class="function">
<dt id="d2o.utils.calc.exponential_decay">
<code class="descclassname">d2o.utils.calc.</code><code class="descname">exponential_decay</code><span class="sig-paren">(</span><em>n_zero</em>, <em>steps</em>, <em>decay_rate=1.0</em><span class="sig-paren">)</span><a class="reference internal" href="_modules/d2o/utils/calc.html#exponential_decay"><span class="viewcode-link">[source]</span></a><a class="headerlink" href="#d2o.utils.calc.exponential_decay" title="Permalink to this definition">¶</a></dt>
<dd></dd></dl>

<dl class="function">
<dt id="d2o.utils.calc.exponential_growth">
<code class="descclassname">d2o.utils.calc.</code><code class="descname">exponential_growth</code><span class="sig-paren">(</span><em>n_zero</em>, <em>steps</em>, <em>growth_rate=1.0</em><span class="sig-paren">)</span><a class="reference internal" href="_modules/d2o/utils/calc.html#exponential_growth"><span class="viewcode-link">[source]</span></a><a class="headerlink" href="#d2o.utils.calc.exponential_growth" title="Permalink to this definition">¶</a></dt>
<dd></dd></dl>

<dl class="function">
<dt id="d2o.utils.calc.moving_average">
<code class="descclassname">d2o.utils.calc.</code><code class="descname">moving_average</code><span class="sig-paren">(</span><em>x</em>, <em>window_size</em><span class="sig-paren">)</span><a class="reference internal" href="_modules/d2o/utils/calc.html#moving_average"><span class="viewcode-link">[source]</span></a><a class="headerlink" href="#d2o.utils.calc.moving_average" title="Permalink to this definition">¶</a></dt>
<dd></dd></dl>

<dl class="function">
<dt id="d2o.utils.calc.moving_average_mat">
<code class="descclassname">d2o.utils.calc.</code><code class="descname">moving_average_mat</code><span class="sig-paren">(</span><em>mat</em>, <em>window_size</em><span class="sig-paren">)</span><a class="reference internal" href="_modules/d2o/utils/calc.html#moving_average_mat"><span class="viewcode-link">[source]</span></a><a class="headerlink" href="#d2o.utils.calc.moving_average_mat" title="Permalink to this definition">¶</a></dt>
<dd></dd></dl>

<dl class="function">
<dt id="d2o.utils.calc.variance">
<code class="descclassname">d2o.utils.calc.</code><code class="descname">variance</code><span class="sig-paren">(</span><em>array</em><span class="sig-paren">)</span><a class="reference internal" href="_modules/d2o/utils/calc.html#variance"><span class="viewcode-link">[source]</span></a><a class="headerlink" href="#d2o.utils.calc.variance" title="Permalink to this definition">¶</a></dt>
<dd></dd></dl>

</div>
<div class="section" id="module-d2o.utils.email">
<span id="d2o-utils-email-module"></span><h2>d2o.utils.email module<a class="headerlink" href="#module-d2o.utils.email" title="Permalink to this headline">¶</a></h2>
<dl class="class">
<dt id="d2o.utils.email.Email">
<em class="property">class </em><code class="descclassname">d2o.utils.email.</code><code class="descname">Email</code><span class="sig-paren">(</span><em>address</em>, <em>port</em>, <em>username</em>, <em>password</em><span class="sig-paren">)</span><a class="reference internal" href="_modules/d2o/utils/email.html#Email"><span class="viewcode-link">[source]</span></a><a class="headerlink" href="#d2o.utils.email.Email" title="Permalink to this definition">¶</a></dt>
<dd><dl class="method">
<dt id="d2o.utils.email.Email.send">
<code class="descname">send</code><span class="sig-paren">(</span><em>sender</em>, <em>recipient</em>, <em>subject</em>, <em>message</em><span class="sig-paren">)</span><a class="reference internal" href="_modules/d2o/utils/email.html#Email.send"><span class="viewcode-link">[source]</span></a><a class="headerlink" href="#d2o.utils.email.Email.send" title="Permalink to this definition">¶</a></dt>
<dd></dd></dl>

</dd></dl>

</div>
<div class="section" id="module-d2o.utils.errors">
<span id="d2o-utils-errors-module"></span><h2>d2o.utils.errors module<a class="headerlink" href="#module-d2o.utils.errors" title="Permalink to this headline">¶</a></h2>
<dl class="function">
<dt id="d2o.utils.errors.absolute_error">
<code class="descclassname">d2o.utils.errors.</code><code class="descname">absolute_error</code><span class="sig-paren">(</span><em>approximate</em>, <em>exact</em><span class="sig-paren">)</span><a class="reference internal" href="_modules/d2o/utils/errors.html#absolute_error"><span class="viewcode-link">[source]</span></a><a class="headerlink" href="#d2o.utils.errors.absolute_error" title="Permalink to this definition">¶</a></dt>
<dd></dd></dl>

<dl class="function">
<dt id="d2o.utils.errors.float_equal">
<code class="descclassname">d2o.utils.errors.</code><code class="descname">float_equal</code><span class="sig-paren">(</span><em>x</em>, <em>y</em>, <em>limit=0.001</em><span class="sig-paren">)</span><a class="reference internal" href="_modules/d2o/utils/errors.html#float_equal"><span class="viewcode-link">[source]</span></a><a class="headerlink" href="#d2o.utils.errors.float_equal" title="Permalink to this definition">¶</a></dt>
<dd></dd></dl>

<dl class="function">
<dt id="d2o.utils.errors.hits">
<code class="descclassname">d2o.utils.errors.</code><code class="descname">hits</code><span class="sig-paren">(</span><em>approximate</em>, <em>exact</em>, <em>th=None</em><span class="sig-paren">)</span><a class="reference internal" href="_modules/d2o/utils/errors.html#hits"><span class="viewcode-link">[source]</span></a><a class="headerlink" href="#d2o.utils.errors.hits" title="Permalink to this definition">¶</a></dt>
<dd></dd></dl>

<dl class="function">
<dt id="d2o.utils.errors.is_numeric">
<code class="descclassname">d2o.utils.errors.</code><code class="descname">is_numeric</code><span class="sig-paren">(</span><em>obj</em><span class="sig-paren">)</span><a class="reference internal" href="_modules/d2o/utils/errors.html#is_numeric"><span class="viewcode-link">[source]</span></a><a class="headerlink" href="#d2o.utils.errors.is_numeric" title="Permalink to this definition">¶</a></dt>
<dd></dd></dl>

<dl class="function">
<dt id="d2o.utils.errors.mae">
<code class="descclassname">d2o.utils.errors.</code><code class="descname">mae</code><span class="sig-paren">(</span><em>approximate</em>, <em>exact</em>, <em>median=False</em><span class="sig-paren">)</span><a class="reference internal" href="_modules/d2o/utils/errors.html#mae"><span class="viewcode-link">[source]</span></a><a class="headerlink" href="#d2o.utils.errors.mae" title="Permalink to this definition">¶</a></dt>
<dd></dd></dl>

<dl class="function">
<dt id="d2o.utils.errors.mape">
<code class="descclassname">d2o.utils.errors.</code><code class="descname">mape</code><span class="sig-paren">(</span><em>approximate</em>, <em>exact</em>, <em>median=False</em><span class="sig-paren">)</span><a class="reference internal" href="_modules/d2o/utils/errors.html#mape"><span class="viewcode-link">[source]</span></a><a class="headerlink" href="#d2o.utils.errors.mape" title="Permalink to this definition">¶</a></dt>
<dd></dd></dl>

<dl class="function">
<dt id="d2o.utils.errors.mase">
<code class="descclassname">d2o.utils.errors.</code><code class="descname">mase</code><span class="sig-paren">(</span><em>train</em>, <em>approximate</em>, <em>exact</em><span class="sig-paren">)</span><a class="reference internal" href="_modules/d2o/utils/errors.html#mase"><span class="viewcode-link">[source]</span></a><a class="headerlink" href="#d2o.utils.errors.mase" title="Permalink to this definition">¶</a></dt>
<dd></dd></dl>

<dl class="function">
<dt id="d2o.utils.errors.mse">
<code class="descclassname">d2o.utils.errors.</code><code class="descname">mse</code><span class="sig-paren">(</span><em>approximate</em>, <em>exact</em><span class="sig-paren">)</span><a class="reference internal" href="_modules/d2o/utils/errors.html#mse"><span class="viewcode-link">[source]</span></a><a class="headerlink" href="#d2o.utils.errors.mse" title="Permalink to this definition">¶</a></dt>
<dd></dd></dl>

<dl class="function">
<dt id="d2o.utils.errors.percent_difference">
<code class="descclassname">d2o.utils.errors.</code><code class="descname">percent_difference</code><span class="sig-paren">(</span><em>val1</em>, <em>val2</em><span class="sig-paren">)</span><a class="reference internal" href="_modules/d2o/utils/errors.html#percent_difference"><span class="viewcode-link">[source]</span></a><a class="headerlink" href="#d2o.utils.errors.percent_difference" title="Permalink to this definition">¶</a></dt>
<dd></dd></dl>

<dl class="function">
<dt id="d2o.utils.errors.percent_error">
<code class="descclassname">d2o.utils.errors.</code><code class="descname">percent_error</code><span class="sig-paren">(</span><em>approximate</em>, <em>exact</em><span class="sig-paren">)</span><a class="reference internal" href="_modules/d2o/utils/errors.html#percent_error"><span class="viewcode-link">[source]</span></a><a class="headerlink" href="#d2o.utils.errors.percent_error" title="Permalink to this definition">¶</a></dt>
<dd></dd></dl>

<dl class="function">
<dt id="d2o.utils.errors.percent_hits">
<code class="descclassname">d2o.utils.errors.</code><code class="descname">percent_hits</code><span class="sig-paren">(</span><em>approximate</em>, <em>exact</em>, <em>th=None</em><span class="sig-paren">)</span><a class="reference internal" href="_modules/d2o/utils/errors.html#percent_hits"><span class="viewcode-link">[source]</span></a><a class="headerlink" href="#d2o.utils.errors.percent_hits" title="Permalink to this definition">¶</a></dt>
<dd></dd></dl>

<dl class="function">
<dt id="d2o.utils.errors.relative_error">
<code class="descclassname">d2o.utils.errors.</code><code class="descname">relative_error</code><span class="sig-paren">(</span><em>approximate</em>, <em>exact</em><span class="sig-paren">)</span><a class="reference internal" href="_modules/d2o/utils/errors.html#relative_error"><span class="viewcode-link">[source]</span></a><a class="headerlink" href="#d2o.utils.errors.relative_error" title="Permalink to this definition">¶</a></dt>
<dd></dd></dl>

<dl class="function">
<dt id="d2o.utils.errors.rmse">
<code class="descclassname">d2o.utils.errors.</code><code class="descname">rmse</code><span class="sig-paren">(</span><em>approximate</em>, <em>exact</em><span class="sig-paren">)</span><a class="reference internal" href="_modules/d2o/utils/errors.html#rmse"><span class="viewcode-link">[source]</span></a><a class="headerlink" href="#d2o.utils.errors.rmse" title="Permalink to this definition">¶</a></dt>
<dd></dd></dl>

<dl class="function">
<dt id="d2o.utils.errors.sapes">
<code class="descclassname">d2o.utils.errors.</code><code class="descname">sapes</code><span class="sig-paren">(</span><em>approximate</em>, <em>exact</em><span class="sig-paren">)</span><a class="reference internal" href="_modules/d2o/utils/errors.html#sapes"><span class="viewcode-link">[source]</span></a><a class="headerlink" href="#d2o.utils.errors.sapes" title="Permalink to this definition">¶</a></dt>
<dd></dd></dl>

<dl class="function">
<dt id="d2o.utils.errors.smape">
<code class="descclassname">d2o.utils.errors.</code><code class="descname">smape</code><span class="sig-paren">(</span><em>approximate</em>, <em>exact</em>, <em>median=False</em><span class="sig-paren">)</span><a class="reference internal" href="_modules/d2o/utils/errors.html#smape"><span class="viewcode-link">[source]</span></a><a class="headerlink" href="#d2o.utils.errors.smape" title="Permalink to this definition">¶</a></dt>
<dd></dd></dl>

<dl class="function">
<dt id="d2o.utils.errors.to_array">
<code class="descclassname">d2o.utils.errors.</code><code class="descname">to_array</code><span class="sig-paren">(</span><em>l</em><span class="sig-paren">)</span><a class="reference internal" href="_modules/d2o/utils/errors.html#to_array"><span class="viewcode-link">[source]</span></a><a class="headerlink" href="#d2o.utils.errors.to_array" title="Permalink to this definition">¶</a></dt>
<dd></dd></dl>

</div>
<div class="section" id="module-d2o.utils.handlers">
<span id="d2o-utils-handlers-module"></span><h2>d2o.utils.handlers module<a class="headerlink" href="#module-d2o.utils.handlers" title="Permalink to this headline">¶</a></h2>
<dl class="class">
<dt id="d2o.utils.handlers.ExceptionHandler">
<em class="property">class </em><code class="descclassname">d2o.utils.handlers.</code><code class="descname">ExceptionHandler</code><span class="sig-paren">(</span><em>exception</em><span class="sig-paren">)</span><a class="reference internal" href="_modules/d2o/utils/handlers.html#ExceptionHandler"><span class="viewcode-link">[source]</span></a><a class="headerlink" href="#d2o.utils.handlers.ExceptionHandler" title="Permalink to this definition">¶</a></dt>
<dd><dl class="method">
<dt id="d2o.utils.handlers.ExceptionHandler.format">
<code class="descname">format</code><span class="sig-paren">(</span><span class="sig-paren">)</span><a class="reference internal" href="_modules/d2o/utils/handlers.html#ExceptionHandler.format"><span class="viewcode-link">[source]</span></a><a class="headerlink" href="#d2o.utils.handlers.ExceptionHandler.format" title="Permalink to this definition">¶</a></dt>
<dd></dd></dl>

</dd></dl>

</div>
<div class="section" id="module-d2o.utils.logger">
<span id="d2o-utils-logger-module"></span><h2>d2o.utils.logger module<a class="headerlink" href="#module-d2o.utils.logger" title="Permalink to this headline">¶</a></h2>
<dl class="function">
<dt id="d2o.utils.logger.dbg">
<code class="descclassname">d2o.utils.logger.</code><code class="descname">dbg</code><span class="sig-paren">(</span><em>message</em><span class="sig-paren">)</span><a class="reference internal" href="_modules/d2o/utils/logger.html#dbg"><span class="viewcode-link">[source]</span></a><a class="headerlink" href="#d2o.utils.logger.dbg" title="Permalink to this definition">¶</a></dt>
<dd></dd></dl>

<dl class="function">
<dt id="d2o.utils.logger.debug">
<code class="descclassname">d2o.utils.logger.</code><code class="descname">debug</code><span class="sig-paren">(</span><em>message</em><span class="sig-paren">)</span><a class="reference internal" href="_modules/d2o/utils/logger.html#debug"><span class="viewcode-link">[source]</span></a><a class="headerlink" href="#d2o.utils.logger.debug" title="Permalink to this definition">¶</a></dt>
<dd></dd></dl>

<dl class="function">
<dt id="d2o.utils.logger.disable_colors">
<code class="descclassname">d2o.utils.logger.</code><code class="descname">disable_colors</code><span class="sig-paren">(</span><span class="sig-paren">)</span><a class="reference internal" href="_modules/d2o/utils/logger.html#disable_colors"><span class="viewcode-link">[source]</span></a><a class="headerlink" href="#d2o.utils.logger.disable_colors" title="Permalink to this definition">¶</a></dt>
<dd></dd></dl>

<dl class="function">
<dt id="d2o.utils.logger.disable_inspection">
<code class="descclassname">d2o.utils.logger.</code><code class="descname">disable_inspection</code><span class="sig-paren">(</span><span class="sig-paren">)</span><a class="reference internal" href="_modules/d2o/utils/logger.html#disable_inspection"><span class="viewcode-link">[source]</span></a><a class="headerlink" href="#d2o.utils.logger.disable_inspection" title="Permalink to this definition">¶</a></dt>
<dd></dd></dl>

<dl class="function">
<dt id="d2o.utils.logger.disable_logging">
<code class="descclassname">d2o.utils.logger.</code><code class="descname">disable_logging</code><span class="sig-paren">(</span><span class="sig-paren">)</span><a class="reference internal" href="_modules/d2o/utils/logger.html#disable_logging"><span class="viewcode-link">[source]</span></a><a class="headerlink" href="#d2o.utils.logger.disable_logging" title="Permalink to this definition">¶</a></dt>
<dd></dd></dl>

<dl class="function">
<dt id="d2o.utils.logger.enable_colors">
<code class="descclassname">d2o.utils.logger.</code><code class="descname">enable_colors</code><span class="sig-paren">(</span><span class="sig-paren">)</span><a class="reference internal" href="_modules/d2o/utils/logger.html#enable_colors"><span class="viewcode-link">[source]</span></a><a class="headerlink" href="#d2o.utils.logger.enable_colors" title="Permalink to this definition">¶</a></dt>
<dd></dd></dl>

<dl class="function">
<dt id="d2o.utils.logger.enable_inspection">
<code class="descclassname">d2o.utils.logger.</code><code class="descname">enable_inspection</code><span class="sig-paren">(</span><span class="sig-paren">)</span><a class="reference internal" href="_modules/d2o/utils/logger.html#enable_inspection"><span class="viewcode-link">[source]</span></a><a class="headerlink" href="#d2o.utils.logger.enable_inspection" title="Permalink to this definition">¶</a></dt>
<dd></dd></dl>

<dl class="function">
<dt id="d2o.utils.logger.enable_logging">
<code class="descclassname">d2o.utils.logger.</code><code class="descname">enable_logging</code><span class="sig-paren">(</span><span class="sig-paren">)</span><a class="reference internal" href="_modules/d2o/utils/logger.html#enable_logging"><span class="viewcode-link">[source]</span></a><a class="headerlink" href="#d2o.utils.logger.enable_logging" title="Permalink to this definition">¶</a></dt>
<dd></dd></dl>

<dl class="function">
<dt id="d2o.utils.logger.err">
<code class="descclassname">d2o.utils.logger.</code><code class="descname">err</code><span class="sig-paren">(</span><em>message</em><span class="sig-paren">)</span><a class="reference internal" href="_modules/d2o/utils/logger.html#err"><span class="viewcode-link">[source]</span></a><a class="headerlink" href="#d2o.utils.logger.err" title="Permalink to this definition">¶</a></dt>
<dd></dd></dl>

<dl class="function">
<dt id="d2o.utils.logger.error">
<code class="descclassname">d2o.utils.logger.</code><code class="descname">error</code><span class="sig-paren">(</span><em>message</em><span class="sig-paren">)</span><a class="reference internal" href="_modules/d2o/utils/logger.html#error"><span class="viewcode-link">[source]</span></a><a class="headerlink" href="#d2o.utils.logger.error" title="Permalink to this definition">¶</a></dt>
<dd></dd></dl>

<dl class="function">
<dt id="d2o.utils.logger.fail">
<code class="descclassname">d2o.utils.logger.</code><code class="descname">fail</code><span class="sig-paren">(</span><em>message</em><span class="sig-paren">)</span><a class="reference internal" href="_modules/d2o/utils/logger.html#fail"><span class="viewcode-link">[source]</span></a><a class="headerlink" href="#d2o.utils.logger.fail" title="Permalink to this definition">¶</a></dt>
<dd></dd></dl>

<dl class="function">
<dt id="d2o.utils.logger.info">
<code class="descclassname">d2o.utils.logger.</code><code class="descname">info</code><span class="sig-paren">(</span><em>message</em><span class="sig-paren">)</span><a class="reference internal" href="_modules/d2o/utils/logger.html#info"><span class="viewcode-link">[source]</span></a><a class="headerlink" href="#d2o.utils.logger.info" title="Permalink to this definition">¶</a></dt>
<dd></dd></dl>

<dl class="function">
<dt id="d2o.utils.logger.log_message">
<code class="descclassname">d2o.utils.logger.</code><code class="descname">log_message</code><span class="sig-paren">(</span><em>message</em>, <em>verbosity_level</em><span class="sig-paren">)</span><a class="reference internal" href="_modules/d2o/utils/logger.html#log_message"><span class="viewcode-link">[source]</span></a><a class="headerlink" href="#d2o.utils.logger.log_message" title="Permalink to this definition">¶</a></dt>
<dd></dd></dl>

<dl class="function">
<dt id="d2o.utils.logger.msg">
<code class="descclassname">d2o.utils.logger.</code><code class="descname">msg</code><span class="sig-paren">(</span><em>message</em><span class="sig-paren">)</span><a class="reference internal" href="_modules/d2o/utils/logger.html#msg"><span class="viewcode-link">[source]</span></a><a class="headerlink" href="#d2o.utils.logger.msg" title="Permalink to this definition">¶</a></dt>
<dd></dd></dl>

<dl class="function">
<dt id="d2o.utils.logger.notify">
<code class="descclassname">d2o.utils.logger.</code><code class="descname">notify</code><span class="sig-paren">(</span><em>message</em><span class="sig-paren">)</span><a class="reference internal" href="_modules/d2o/utils/logger.html#notify"><span class="viewcode-link">[source]</span></a><a class="headerlink" href="#d2o.utils.logger.notify" title="Permalink to this definition">¶</a></dt>
<dd></dd></dl>

<dl class="function">
<dt id="d2o.utils.logger.print_message">
<code class="descclassname">d2o.utils.logger.</code><code class="descname">print_message</code><span class="sig-paren">(</span><em>message</em>, <em>verbosity_level</em><span class="sig-paren">)</span><a class="reference internal" href="_modules/d2o/utils/logger.html#print_message"><span class="viewcode-link">[source]</span></a><a class="headerlink" href="#d2o.utils.logger.print_message" title="Permalink to this definition">¶</a></dt>
<dd></dd></dl>

<dl class="function">
<dt id="d2o.utils.logger.progress">
<code class="descclassname">d2o.utils.logger.</code><code class="descname">progress</code><span class="sig-paren">(</span><em>i</em>, <em>total</em>, <em>mod=100</em><span class="sig-paren">)</span><a class="reference internal" href="_modules/d2o/utils/logger.html#progress"><span class="viewcode-link">[source]</span></a><a class="headerlink" href="#d2o.utils.logger.progress" title="Permalink to this definition">¶</a></dt>
<dd></dd></dl>

<dl class="function">
<dt id="d2o.utils.logger.set_log_verbosity">
<code class="descclassname">d2o.utils.logger.</code><code class="descname">set_log_verbosity</code><span class="sig-paren">(</span><em>v</em><span class="sig-paren">)</span><a class="reference internal" href="_modules/d2o/utils/logger.html#set_log_verbosity"><span class="viewcode-link">[source]</span></a><a class="headerlink" href="#d2o.utils.logger.set_log_verbosity" title="Permalink to this definition">¶</a></dt>
<dd></dd></dl>

<dl class="function">
<dt id="d2o.utils.logger.set_logdir">
<code class="descclassname">d2o.utils.logger.</code><code class="descname">set_logdir</code><span class="sig-paren">(</span><em>path</em><span class="sig-paren">)</span><a class="reference internal" href="_modules/d2o/utils/logger.html#set_logdir"><span class="viewcode-link">[source]</span></a><a class="headerlink" href="#d2o.utils.logger.set_logdir" title="Permalink to this definition">¶</a></dt>
<dd></dd></dl>

<dl class="function">
<dt id="d2o.utils.logger.set_print_verbosity">
<code class="descclassname">d2o.utils.logger.</code><code class="descname">set_print_verbosity</code><span class="sig-paren">(</span><em>v</em><span class="sig-paren">)</span><a class="reference internal" href="_modules/d2o/utils/logger.html#set_print_verbosity"><span class="viewcode-link">[source]</span></a><a class="headerlink" href="#d2o.utils.logger.set_print_verbosity" title="Permalink to this definition">¶</a></dt>
<dd></dd></dl>

<dl class="function">
<dt id="d2o.utils.logger.success">
<code class="descclassname">d2o.utils.logger.</code><code class="descname">success</code><span class="sig-paren">(</span><em>message</em><span class="sig-paren">)</span><a class="reference internal" href="_modules/d2o/utils/logger.html#success"><span class="viewcode-link">[source]</span></a><a class="headerlink" href="#d2o.utils.logger.success" title="Permalink to this definition">¶</a></dt>
<dd></dd></dl>

<dl class="function">
<dt id="d2o.utils.logger.warn">
<code class="descclassname">d2o.utils.logger.</code><code class="descname">warn</code><span class="sig-paren">(</span><em>message</em><span class="sig-paren">)</span><a class="reference internal" href="_modules/d2o/utils/logger.html#warn"><span class="viewcode-link">[source]</span></a><a class="headerlink" href="#d2o.utils.logger.warn" title="Permalink to this definition">¶</a></dt>
<dd></dd></dl>

<dl class="function">
<dt id="d2o.utils.logger.warning">
<code class="descclassname">d2o.utils.logger.</code><code class="descname">warning</code><span class="sig-paren">(</span><em>message</em><span class="sig-paren">)</span><a class="reference internal" href="_modules/d2o/utils/logger.html#warning"><span class="viewcode-link">[source]</span></a><a class="headerlink" href="#d2o.utils.logger.warning" title="Permalink to this definition">¶</a></dt>
<dd></dd></dl>

</div>
<div class="section" id="module-d2o.utils.putils">
<span id="d2o-utils-putils-module"></span><h2>d2o.utils.putils module<a class="headerlink" href="#module-d2o.utils.putils" title="Permalink to this headline">¶</a></h2>
<dl class="function">
<dt id="d2o.utils.putils.add_mav">
<code class="descclassname">d2o.utils.putils.</code><code class="descname">add_mav</code><span class="sig-paren">(</span><em>df</em>, <em>window_size</em><span class="sig-paren">)</span><a class="reference internal" href="_modules/d2o/utils/putils.html#add_mav"><span class="viewcode-link">[source]</span></a><a class="headerlink" href="#d2o.utils.putils.add_mav" title="Permalink to this definition">¶</a></dt>
<dd><table class="docutils field-list" frame="void" rules="none">
<col class="field-name" />
<col class="field-body" />
<tbody valign="top">
<tr class="field-odd field"><th class="field-name">Parameters:</th><td class="field-body"><p class="first"><strong>df</strong> : pd.DataFrame</p>
<p><strong>window_size</strong> : int</p>
</td>
</tr>
<tr class="field-even field"><th class="field-name">Returns:</th><td class="field-body"><p class="first"><strong>combined_df</strong> : pd.dataframe</p>
<blockquote class="last">
<div><p>df with extra columns containing the moving average. Columns with moving average
is named by appending &#8220;_MAV&#8221; to the end of the column name/key.</p>
</div></blockquote>
</td>
</tr>
</tbody>
</table>
</dd></dl>

<dl class="function">
<dt id="d2o.utils.putils.combine">
<code class="descclassname">d2o.utils.putils.</code><code class="descname">combine</code><span class="sig-paren">(</span><em>df_list</em><span class="sig-paren">)</span><a class="reference internal" href="_modules/d2o/utils/putils.html#combine"><span class="viewcode-link">[source]</span></a><a class="headerlink" href="#d2o.utils.putils.combine" title="Permalink to this definition">¶</a></dt>
<dd><p>Combines the data frames in df_list into one data frame.</p>
<table class="docutils field-list" frame="void" rules="none">
<col class="field-name" />
<col class="field-body" />
<tbody valign="top">
<tr class="field-odd field"><th class="field-name">Parameters:</th><td class="field-body"><p class="first"><strong>df_list</strong> : list of pd.DataFrame</p>
</td>
</tr>
<tr class="field-even field"><th class="field-name">Returns:</th><td class="field-body"><p class="first"><strong>concat_df</strong> : pd.DataFrame</p>
<blockquote class="last">
<div><p>The composite data frame of all the data frames in df_list.</p>
</div></blockquote>
</td>
</tr>
</tbody>
</table>
<p class="rubric">Notes</p>
<p>The combination is done by &#8216;adding&#8217; the columns of the data frames to one big
data frame.</p>
<p>ex: df_1 contains columns &#8216;A and &#8216;B&#8217;, df_2 contains &#8216;C&#8217; and &#8216;D&#8217;. Then the composite
data frame df_composite have columns &#8216;A&#8217;, &#8216;B&#8217;, &#8216;C&#8217; and &#8216;D&#8217;.</p>
</dd></dl>

<dl class="function">
<dt id="d2o.utils.putils.create_labels">
<code class="descclassname">d2o.utils.putils.</code><code class="descname">create_labels</code><span class="sig-paren">(</span><em>title=''</em>, <em>subtitle=''</em>, <em>xlabel=''</em>, <em>ylabel=''</em><span class="sig-paren">)</span><a class="reference internal" href="_modules/d2o/utils/putils.html#create_labels"><span class="viewcode-link">[source]</span></a><a class="headerlink" href="#d2o.utils.putils.create_labels" title="Permalink to this definition">¶</a></dt>
<dd><p>Creates a dictionary with title, subtitle, xlabel an ylabel.</p>
<table class="docutils field-list" frame="void" rules="none">
<col class="field-name" />
<col class="field-body" />
<tbody valign="top">
<tr class="field-odd field"><th class="field-name">Returns:</th><td class="field-body"><strong>labels</strong> : dict</td>
</tr>
</tbody>
</table>
</dd></dl>

<dl class="function">
<dt id="d2o.utils.putils.distance">
<code class="descclassname">d2o.utils.putils.</code><code class="descname">distance</code><span class="sig-paren">(</span><em>df1</em>, <em>df2</em><span class="sig-paren">)</span><a class="reference internal" href="_modules/d2o/utils/putils.html#distance"><span class="viewcode-link">[source]</span></a><a class="headerlink" href="#d2o.utils.putils.distance" title="Permalink to this definition">¶</a></dt>
<dd><p>Computes the sum of the elementvise absolute difference between the data frames.</p>
<table class="docutils field-list" frame="void" rules="none">
<col class="field-name" />
<col class="field-body" />
<tbody valign="top">
<tr class="field-odd field"><th class="field-name">Parameters:</th><td class="field-body"><p class="first"><strong>df1</strong> : pd.DataFrame</p>
<p><strong>df2</strong> : pd.DataFrame</p>
</td>
</tr>
<tr class="field-even field"><th class="field-name">Returns:</th><td class="field-body"><p class="first last"><strong>distance</strong> : float</p>
</td>
</tr>
</tbody>
</table>
<p class="rubric">Notes</p>
<p>The dataframes must be of same shape and contain floats.</p>
</dd></dl>

<dl class="function">
<dt id="d2o.utils.putils.expand_date_index">
<code class="descclassname">d2o.utils.putils.</code><code class="descname">expand_date_index</code><span class="sig-paren">(</span><em>df</em>, <em>precision='day'</em><span class="sig-paren">)</span><a class="reference internal" href="_modules/d2o/utils/putils.html#expand_date_index"><span class="viewcode-link">[source]</span></a><a class="headerlink" href="#d2o.utils.putils.expand_date_index" title="Permalink to this definition">¶</a></dt>
<dd><p>Adds columns for year, month, week and so on. Highest precision is &#8216;hour&#8217;.</p>
<table class="docutils field-list" frame="void" rules="none">
<col class="field-name" />
<col class="field-body" />
<tbody valign="top">
<tr class="field-odd field"><th class="field-name">Parameters:</th><td class="field-body"><p class="first"><strong>df</strong> : pd.DataFrame</p>
<p><strong>precision</strong> : str, default &#8216;day&#8217;</p>
<blockquote>
<div><p>Can be set to &#8216;hour&#8217; for max precision, anything else will give the standard
&#8216;Weekday&#8217;, &#8216;Week&#8217;, &#8216;Month&#8217; and &#8216;Year&#8217; columns.</p>
</div></blockquote>
</td>
</tr>
<tr class="field-even field"><th class="field-name">Returns:</th><td class="field-body"><p class="first"><strong>df</strong> : pd.DataFrame</p>
<blockquote class="last">
<div><p>Dataframe with date information expanded in to several columns.</p>
</div></blockquote>
</td>
</tr>
</tbody>
</table>
</dd></dl>

<dl class="function">
<dt id="d2o.utils.putils.from_csv">
<code class="descclassname">d2o.utils.putils.</code><code class="descname">from_csv</code><span class="sig-paren">(</span><em>path</em>, <em>*args</em>, <em>**kwargs</em><span class="sig-paren">)</span><a class="reference internal" href="_modules/d2o/utils/putils.html#from_csv"><span class="viewcode-link">[source]</span></a><a class="headerlink" href="#d2o.utils.putils.from_csv" title="Permalink to this definition">¶</a></dt>
<dd><p>A wrap of pd.read_csv(). all arguments are passed to that function.</p>
</dd></dl>

<dl class="function">
<dt id="d2o.utils.putils.get_path_to_dataset">
<code class="descclassname">d2o.utils.putils.</code><code class="descname">get_path_to_dataset</code><span class="sig-paren">(</span><em>dataset</em><span class="sig-paren">)</span><a class="reference internal" href="_modules/d2o/utils/putils.html#get_path_to_dataset"><span class="viewcode-link">[source]</span></a><a class="headerlink" href="#d2o.utils.putils.get_path_to_dataset" title="Permalink to this definition">¶</a></dt>
<dd><p>Used for testing.
Requires the d2o/data/datasets/testdata/ directory.
Get path to datset without initializing during import.</p>
<table class="docutils field-list" frame="void" rules="none">
<col class="field-name" />
<col class="field-body" />
<tbody valign="top">
<tr class="field-odd field"><th class="field-name">Parameters:</th><td class="field-body"><p class="first"><strong>dataset</strong> : str</p>
<blockquote>
<div><p>Name.</p>
</div></blockquote>
</td>
</tr>
<tr class="field-even field"><th class="field-name">Returns:</th><td class="field-body"><p class="first"><strong>file_path</strong> : str</p>
<blockquote class="last">
<div><p>File path to dataset.</p>
</div></blockquote>
</td>
</tr>
</tbody>
</table>
</dd></dl>

<dl class="function">
<dt id="d2o.utils.putils.impute">
<code class="descclassname">d2o.utils.putils.</code><code class="descname">impute</code><span class="sig-paren">(</span><em>df</em>, <em>freq='D'</em>, <em>method='median'</em><span class="sig-paren">)</span><a class="reference internal" href="_modules/d2o/utils/putils.html#impute"><span class="viewcode-link">[source]</span></a><a class="headerlink" href="#d2o.utils.putils.impute" title="Permalink to this definition">¶</a></dt>
<dd><p>Imputes all missing values in all columns including the index column. Currently only works for
data frames with indexcolumn with type DatatimeIndex.</p>
<table class="docutils field-list" frame="void" rules="none">
<col class="field-name" />
<col class="field-body" />
<tbody valign="top">
<tr class="field-odd field"><th class="field-name">Parameters:</th><td class="field-body"><p class="first"><strong>df</strong> : pd.DataFrame</p>
<blockquote>
<div><p>Data frame with missing values.</p>
</div></blockquote>
<p><strong>freq</strong> : str, default &#8216;D&#8217;</p>
<blockquote>
<div><p>The resolution used to impute. &#8216;D&#8217; means impute days, &#8216;W&#8217; means week etc.</p>
</div></blockquote>
<p><strong>method</strong> : str, default &#8216;median&#8217;</p>
<blockquote>
<div><p>What imputatin method to use. valid_methods: {&#8216;zero&#8217;,&#8217;mean&#8217;,&#8217;median&#8217;, &#8216;nan&#8217;}</p>
</div></blockquote>
</td>
</tr>
<tr class="field-even field"><th class="field-name">Returns:</th><td class="field-body"><p class="first last"><strong>imputed</strong> : pd.DataFrame</p>
</td>
</tr>
</tbody>
</table>
<div class="admonition seealso">
<p class="first admonition-title">See also</p>
<p><code class="xref py py-obj docutils literal"><span class="pre">pd.date_range</span></code>, <code class="xref py py-obj docutils literal"><span class="pre">end</span></code>, <code class="xref py py-obj docutils literal"><span class="pre">freq</span></code></p>
<dl class="last docutils">
<dt><code class="xref py py-obj docutils literal"><span class="pre">http</span></code></dt>
<dd>//pandas.pydata.org/pandas-docs/stable/generated/pandas.date_range.html</dd>
</dl>
</div>
</dd></dl>

<dl class="function">
<dt id="d2o.utils.putils.impute_weekdays">
<code class="descclassname">d2o.utils.putils.</code><code class="descname">impute_weekdays</code><span class="sig-paren">(</span><em>df</em>, <em>include_zeros=False</em><span class="sig-paren">)</span><a class="reference internal" href="_modules/d2o/utils/putils.html#impute_weekdays"><span class="viewcode-link">[source]</span></a><a class="headerlink" href="#d2o.utils.putils.impute_weekdays" title="Permalink to this definition">¶</a></dt>
<dd><p>Set NaN&#8217;s to that weekday&#8217;s median.</p>
<table class="docutils field-list" frame="void" rules="none">
<col class="field-name" />
<col class="field-body" />
<tbody valign="top">
<tr class="field-odd field"><th class="field-name">Parameters:</th><td class="field-body"><p class="first"><strong>df</strong> : pd.DataFrame</p>
<p><strong>include_zeros</strong> : bool, default False</p>
</td>
</tr>
<tr class="field-even field"><th class="field-name">Returns:</th><td class="field-body"><p class="first"><strong>df</strong> : pd.DataFrame</p>
<blockquote class="last">
<div><p>Dataframe with all zeros set to their weekdays median.</p>
</div></blockquote>
</td>
</tr>
</tbody>
</table>
</dd></dl>

<dl class="function">
<dt id="d2o.utils.putils.nan_to_none">
<code class="descclassname">d2o.utils.putils.</code><code class="descname">nan_to_none</code><span class="sig-paren">(</span><em>df</em><span class="sig-paren">)</span><a class="reference internal" href="_modules/d2o/utils/putils.html#nan_to_none"><span class="viewcode-link">[source]</span></a><a class="headerlink" href="#d2o.utils.putils.nan_to_none" title="Permalink to this definition">¶</a></dt>
<dd><p>Changes all instances of nan to None.</p>
</dd></dl>

<dl class="function">
<dt id="d2o.utils.putils.pad_dates">
<code class="descclassname">d2o.utils.putils.</code><code class="descname">pad_dates</code><span class="sig-paren">(</span><em>dates</em>, <em>freq='D'</em>, <em>length=1</em><span class="sig-paren">)</span><a class="reference internal" href="_modules/d2o/utils/putils.html#pad_dates"><span class="viewcode-link">[source]</span></a><a class="headerlink" href="#d2o.utils.putils.pad_dates" title="Permalink to this definition">¶</a></dt>
<dd><p>Adds padding to the dates provided.</p>
<table class="docutils field-list" frame="void" rules="none">
<col class="field-name" />
<col class="field-body" />
<tbody valign="top">
<tr class="field-odd field"><th class="field-name">Parameters:</th><td class="field-body"><p class="first"><strong>dates</strong> : array_like</p>
<blockquote>
<div><p>List or array with dates in ISO8601 date or datetime format.</p>
</div></blockquote>
<p><strong>freq</strong> : str, default &#8216;D&#8217;</p>
<blockquote>
<div><p>Defines in what scale to pad the dates. valid_frequencies: {&#8216;Y&#8217;,&#8217;M&#8217;,&#8217;W&#8217;,&#8217;D&#8217;,&#8217;h&#8217;,&#8217;m&#8217;,&#8217;s&#8217;, &#8216;ms&#8217;}</p>
</div></blockquote>
<p><strong>length</strong> : int</p>
<blockquote>
<div><p>How much to pad the dates. The dates are padded using &#8216;freq&#8217; to pad &#8216;length&#8217; in each direction.</p>
</div></blockquote>
</td>
</tr>
<tr class="field-even field"><th class="field-name">Returns:</th><td class="field-body"><p class="first"><strong>sorted_padded</strong> : array_like</p>
<blockquote class="last">
<div><p>Sorted and padded list or array of dates.</p>
</div></blockquote>
</td>
</tr>
</tbody>
</table>
<div class="admonition seealso">
<p class="first admonition-title">See also</p>
<dl class="last docutils">
<dt><code class="xref py py-obj docutils literal"><span class="pre">http</span></code></dt>
<dd>//docs.scipy.org/doc/numpy-1.10.1/reference/arrays.datetime.html</dd>
</dl>
</div>
<p class="rubric">Notes</p>
<p>This function assumes that the date format is ISO 8601 date or datetime format.
Some other formats may be accepted. See the link provided in the see also tab.</p>
</dd></dl>

<dl class="function">
<dt id="d2o.utils.putils.plot">
<code class="descclassname">d2o.utils.putils.</code><code class="descname">plot</code><span class="sig-paren">(</span><em>df</em>, <em>labels=None</em>, <em>saveto=None</em>, <em>*args</em>, <em>**kwargs</em><span class="sig-paren">)</span><a class="reference internal" href="_modules/d2o/utils/putils.html#plot"><span class="viewcode-link">[source]</span></a><a class="headerlink" href="#d2o.utils.putils.plot" title="Permalink to this definition">¶</a></dt>
<dd><p>Plots the columns in df on the active matplotlib figure</p>
<table class="docutils field-list" frame="void" rules="none">
<col class="field-name" />
<col class="field-body" />
<tbody valign="top">
<tr class="field-odd field"><th class="field-name">Parameters:</th><td class="field-body"><p class="first"><strong>df</strong> : pd.DataFrame</p>
<p><strong>labels</strong> : dict</p>
<blockquote>
<div><p>Dictionary, see create_labels().</p>
</div></blockquote>
<p><strong>saveto</strong> : str, default None</p>
<blockquote>
<div><p>Filepath to save the figure.</p>
</div></blockquote>
</td>
</tr>
<tr class="field-even field"><th class="field-name">Returns:</th><td class="field-body"><p class="first last">None</p>
</td>
</tr>
</tbody>
</table>
</dd></dl>

<dl class="function">
<dt id="d2o.utils.putils.plot_corr">
<code class="descclassname">d2o.utils.putils.</code><code class="descname">plot_corr</code><span class="sig-paren">(</span><em>df</em>, <em>sort=False</em>, <em>**kwargs</em><span class="sig-paren">)</span><a class="reference internal" href="_modules/d2o/utils/putils.html#plot_corr"><span class="viewcode-link">[source]</span></a><a class="headerlink" href="#d2o.utils.putils.plot_corr" title="Permalink to this definition">¶</a></dt>
<dd><p>Creates a correlation matrix from the datafram and plots it. A plt.show()
call is needed after this function returns to show the figure on screen.</p>
<table class="docutils field-list" frame="void" rules="none">
<col class="field-name" />
<col class="field-body" />
<tbody valign="top">
<tr class="field-odd field"><th class="field-name">Parameters:</th><td class="field-body"><p class="first"><strong>df</strong> : pd.DataFrame</p>
<p><strong>sort</strong> : bool, default False</p>
<blockquote>
<div><p>If True, creates a clustermap using &#8220;method&#8221; kwarg to sort.</p>
</div></blockquote>
</td>
</tr>
<tr class="field-even field"><th class="field-name">Returns:</th><td class="field-body"><p class="first"><strong>f</strong> : plt.Figure, or sns.ClusterGrid</p>
<p><strong>corrmat</strong> : pd.DataFrame</p>
<blockquote class="last">
<div><p>Only gets returned if kwarg &#8216;return_corrmat&#8217; is True.</p>
</div></blockquote>
</td>
</tr>
</tbody>
</table>
<div class="admonition seealso">
<p class="first admonition-title">See also</p>
<p><code class="xref py py-obj docutils literal"><span class="pre">For</span></code></p>
<dl class="last docutils">
<dt><code class="xref py py-obj docutils literal"><span class="pre">http</span></code></dt>
<dd>//docs.scipy.org/doc/scipy/reference/generated/scipy.cluster.hierarchy.linkage.html</dd>
</dl>
</div>
</dd></dl>

<dl class="function">
<dt id="d2o.utils.putils.plot_hist">
<code class="descclassname">d2o.utils.putils.</code><code class="descname">plot_hist</code><span class="sig-paren">(</span><em>df</em>, <em>labels=None</em>, <em>bins=30</em>, <em>rel=False</em>, <em>center_on_bins=False</em><span class="sig-paren">)</span><a class="reference internal" href="_modules/d2o/utils/putils.html#plot_hist"><span class="viewcode-link">[source]</span></a><a class="headerlink" href="#d2o.utils.putils.plot_hist" title="Permalink to this definition">¶</a></dt>
<dd><p>Creates and draws a figure using matplotlib.pyplot</p>
<table class="docutils field-list" frame="void" rules="none">
<col class="field-name" />
<col class="field-body" />
<tbody valign="top">
<tr class="field-odd field"><th class="field-name">Parameters:</th><td class="field-body"><p class="first"><strong>df</strong> : pd.DataFrame</p>
<p><strong>labels</strong> : dict</p>
<p><strong>bins</strong> : int, default 30</p>
<blockquote>
<div><p>Number of bis to use.</p>
</div></blockquote>
<p><strong>rel</strong> : bool, default False</p>
<blockquote>
<div><p>IF True, the values in each bin is relative to the number of entries in df.</p>
</div></blockquote>
<p><strong>center_on_bins</strong> : bool, default False</p>
<blockquote>
<div><p>If True the xticks are centered on the bins instead of left aligned.</p>
</div></blockquote>
</td>
</tr>
<tr class="field-even field"><th class="field-name">Returns:</th><td class="field-body"><p class="first last">None</p>
</td>
</tr>
</tbody>
</table>
</dd></dl>

<dl class="function">
<dt id="d2o.utils.putils.plot_timeseries">
<code class="descclassname">d2o.utils.putils.</code><code class="descname">plot_timeseries</code><span class="sig-paren">(</span><em>df</em>, <em>labels=None</em>, <em>interval=1</em>, <em>saveto=None</em>, <em>*args</em>, <em>**kwargs</em><span class="sig-paren">)</span><a class="reference internal" href="_modules/d2o/utils/putils.html#plot_timeseries"><span class="viewcode-link">[source]</span></a><a class="headerlink" href="#d2o.utils.putils.plot_timeseries" title="Permalink to this definition">¶</a></dt>
<dd><p>Plots the columns in df.</p>
<table class="docutils field-list" frame="void" rules="none">
<col class="field-name" />
<col class="field-body" />
<tbody valign="top">
<tr class="field-odd field"><th class="field-name">Parameters:</th><td class="field-body"><p class="first"><strong>df</strong> : pd.DataFrame</p>
<p><strong>labels</strong> : dict</p>
<blockquote>
<div><p>Dictionary, see create_labels().</p>
</div></blockquote>
<p><strong>interval</strong> : int, default 1</p>
<blockquote>
<div><p>The interval for the ticks on the x-axis.</p>
</div></blockquote>
<p><strong>saveto</strong> : str, default None</p>
<blockquote>
<div><p>Filepath to save the figure.</p>
</div></blockquote>
</td>
</tr>
<tr class="field-even field"><th class="field-name">Returns:</th><td class="field-body"><p class="first last">None</p>
</td>
</tr>
</tbody>
</table>
</dd></dl>

<dl class="function">
<dt id="d2o.utils.putils.remove_by_percentage">
<code class="descclassname">d2o.utils.putils.</code><code class="descname">remove_by_percentage</code><span class="sig-paren">(</span><em>df</em>, <em>percentage</em>, <em>identifier='zero'</em><span class="sig-paren">)</span><a class="reference internal" href="_modules/d2o/utils/putils.html#remove_by_percentage"><span class="viewcode-link">[source]</span></a><a class="headerlink" href="#d2o.utils.putils.remove_by_percentage" title="Permalink to this definition">¶</a></dt>
<dd><p>Removes columns if the amount of &#8216;identifier&#8217; in column is greater than or equal to percentage.</p>
<table class="docutils field-list" frame="void" rules="none">
<col class="field-name" />
<col class="field-body" />
<tbody valign="top">
<tr class="field-odd field"><th class="field-name">Parameters:</th><td class="field-body"><p class="first"><strong>df</strong> : pd.DataFrame</p>
<p><strong>percentage</strong> : float</p>
<p><strong>identifier</strong> : str, default &#8216;zero&#8217;</p>
<blockquote>
<div><p>What type of row value to check for when counting the number of &#8216;missing&#8217; values.
valid identifiers: {&#8216;zero&#8217;, &#8216;nan&#8217;}</p>
</div></blockquote>
</td>
</tr>
<tr class="field-even field"><th class="field-name">Returns:</th><td class="field-body"><p class="first"><strong>df</strong> : pd.DataFrame</p>
<blockquote class="last">
<div><p>Data frame with columns removed.</p>
</div></blockquote>
</td>
</tr>
</tbody>
</table>
</dd></dl>

<dl class="function">
<dt id="d2o.utils.putils.remove_empty_columns">
<code class="descclassname">d2o.utils.putils.</code><code class="descname">remove_empty_columns</code><span class="sig-paren">(</span><em>df</em>, <em>threshp=None</em>, <em>include_zeros=False</em><span class="sig-paren">)</span><a class="reference internal" href="_modules/d2o/utils/putils.html#remove_empty_columns"><span class="viewcode-link">[source]</span></a><a class="headerlink" href="#d2o.utils.putils.remove_empty_columns" title="Permalink to this definition">¶</a></dt>
<dd><p>Removes columns in df if the number of nan in the column is greater than &#8216;threshp&#8217;.</p>
<table class="docutils field-list" frame="void" rules="none">
<col class="field-name" />
<col class="field-body" />
<tbody valign="top">
<tr class="field-odd field"><th class="field-name">Parameters:</th><td class="field-body"><p class="first"><strong>df</strong> : pd.DataFrame</p>
<p><strong>treshp</strong> : float, default None</p>
<blockquote>
<div><p>Value between 0 and 1.</p>
</div></blockquote>
<p><strong>include_zeros</strong> : bool, default False</p>
<blockquote>
<div><p>If True, then zeros will be added to the nan count.</p>
</div></blockquote>
</td>
</tr>
<tr class="field-even field"><th class="field-name">Returns:</th><td class="field-body"><p class="first last"><strong>dropped</strong> : pd.DataFrame</p>
</td>
</tr>
</tbody>
</table>
</dd></dl>

<dl class="function">
<dt id="d2o.utils.putils.replace">
<code class="descclassname">d2o.utils.putils.</code><code class="descname">replace</code><span class="sig-paren">(</span><em>df</em>, <em>value</em>, <em>replace_with=nan</em><span class="sig-paren">)</span><a class="reference internal" href="_modules/d2o/utils/putils.html#replace"><span class="viewcode-link">[source]</span></a><a class="headerlink" href="#d2o.utils.putils.replace" title="Permalink to this definition">¶</a></dt>
<dd><p>Replaces all the instances of &#8216;value&#8217; with replace_with.</p>
<table class="docutils field-list" frame="void" rules="none">
<col class="field-name" />
<col class="field-body" />
<tbody valign="top">
<tr class="field-odd field"><th class="field-name">Parameters:</th><td class="field-body"><p class="first"><strong>df</strong> : pd.DataFrame</p>
<p><strong>value</strong> : any type</p>
<blockquote>
<div><p>The values to replace in df.</p>
</div></blockquote>
<p><strong>replace_with</strong> : any type</p>
<blockquote>
<div><p>If any elements in df is equal to value using the logic element == value
the that element is changed to &#8216;replace with&#8217;.</p>
</div></blockquote>
</td>
</tr>
<tr class="field-even field"><th class="field-name">Returns:</th><td class="field-body"><p class="first last"><strong>df_replaced</strong> : pd.DataFrame</p>
</td>
</tr>
</tbody>
</table>
<p class="rubric">Notes</p>
<p>Uses the pd.DataFrame.applymap() method.</p>
</dd></dl>

<dl class="function">
<dt id="d2o.utils.putils.replace_rows">
<code class="descclassname">d2o.utils.putils.</code><code class="descname">replace_rows</code><span class="sig-paren">(</span><em>df</em>, <em>df_r</em>, <em>indices</em><span class="sig-paren">)</span><a class="reference internal" href="_modules/d2o/utils/putils.html#replace_rows"><span class="viewcode-link">[source]</span></a><a class="headerlink" href="#d2o.utils.putils.replace_rows" title="Permalink to this definition">¶</a></dt>
<dd><p>Replaces rows in df with rows from df_r.
If a column in df is missing values in any of the rows, then those rows are dropped.</p>
<table class="docutils field-list" frame="void" rules="none">
<col class="field-name" />
<col class="field-body" />
<tbody valign="top">
<tr class="field-odd field"><th class="field-name">Parameters:</th><td class="field-body"><p class="first"><strong>df</strong> : pf.DataFrame</p>
<blockquote>
<div><p>Data frame to replace rows in.</p>
</div></blockquote>
<p><strong>df_r</strong> : pd.DataFrame</p>
<blockquote>
<div><p>The replacement rows are taken from this data frame.</p>
</div></blockquote>
</td>
</tr>
<tr class="field-even field"><th class="field-name">Returns:</th><td class="field-body"><p class="first"><strong>dropped</strong> : pd.DataFrame</p>
<blockquote class="last">
<div><p>Data frame with replaced and dropped rows.</p>
</div></blockquote>
</td>
</tr>
</tbody>
</table>
</dd></dl>

<dl class="function">
<dt id="d2o.utils.putils.scale">
<code class="descclassname">d2o.utils.putils.</code><code class="descname">scale</code><span class="sig-paren">(</span><em>df</em>, <em>scaler</em><span class="sig-paren">)</span><a class="reference internal" href="_modules/d2o/utils/putils.html#scale"><span class="viewcode-link">[source]</span></a><a class="headerlink" href="#d2o.utils.putils.scale" title="Permalink to this definition">¶</a></dt>
<dd><p>Scales the values in each column using the provided scaler.</p>
<table class="docutils field-list" frame="void" rules="none">
<col class="field-name" />
<col class="field-body" />
<tbody valign="top">
<tr class="field-odd field"><th class="field-name">Parameters:</th><td class="field-body"><p class="first"><strong>df</strong> : pd.DataFrame</p>
<p><strong>scaler</strong> : d2o.prep.scaling.Scaler instance</p>
</td>
</tr>
<tr class="field-even field"><th class="field-name">Returns:</th><td class="field-body"><p class="first"><strong>sdf</strong> : pd.DataFrame</p>
<blockquote class="last">
<div><p>Scaled data frame.</p>
</div></blockquote>
</td>
</tr>
</tbody>
</table>
</dd></dl>

<dl class="function">
<dt id="d2o.utils.putils.smooth_holidays">
<code class="descclassname">d2o.utils.putils.</code><code class="descname">smooth_holidays</code><span class="sig-paren">(</span><em>df</em>, <em>holidays_df</em>, <em>length=1</em><span class="sig-paren">)</span><a class="reference internal" href="_modules/d2o/utils/putils.html#smooth_holidays"><span class="viewcode-link">[source]</span></a><a class="headerlink" href="#d2o.utils.putils.smooth_holidays" title="Permalink to this definition">¶</a></dt>
<dd><p>Smoothes out peeks and troughs in df, using indices in holiday_df.</p>
<table class="docutils field-list" frame="void" rules="none">
<col class="field-name" />
<col class="field-body" />
<tbody valign="top">
<tr class="field-odd field"><th class="field-name">Parameters:</th><td class="field-body"><p class="first"><strong>df</strong> : pd.DataFrame</p>
<blockquote>
<div><p>Data Frame to smooth.</p>
</div></blockquote>
<p><strong>holidays_df</strong> : pd.DataFrame</p>
<blockquote>
<div><p>Defines the indices to use when smoothing. The function does not care about the values
in holiday_df, only if they are present for a certain row index. This index is then
used to smooth df.</p>
</div></blockquote>
<p><strong>length</strong> : int, default 1</p>
<blockquote>
<div><p>This argument is passed to pad_dates(). This defines the &#8216;padding&#8217; to the holiday.
Assume may 1. is a holiday. If length = 1, then april 30. may 1. and may 2. will
be replaced with a &#8216;smoothed&#8217; value.</p>
</div></blockquote>
</td>
</tr>
<tr class="field-even field"><th class="field-name">Returns:</th><td class="field-body"><p class="first"><strong>smoothed_df</strong> : pd.DataFrame</p>
<blockquote class="last">
<div><p>Data frame with holidays and days leading up to and after, according to length, smoothed.</p>
</div></blockquote>
</td>
</tr>
</tbody>
</table>
</dd></dl>

<dl class="function">
<dt id="d2o.utils.putils.statistics">
<code class="descclassname">d2o.utils.putils.</code><code class="descname">statistics</code><span class="sig-paren">(</span><em>df</em><span class="sig-paren">)</span><a class="reference internal" href="_modules/d2o/utils/putils.html#statistics"><span class="viewcode-link">[source]</span></a><a class="headerlink" href="#d2o.utils.putils.statistics" title="Permalink to this definition">¶</a></dt>
<dd><p>Counts and computes some basic statistics of the dataframe.</p>
<table class="docutils field-list" frame="void" rules="none">
<col class="field-name" />
<col class="field-body" />
<tbody valign="top">
<tr class="field-odd field"><th class="field-name">Parameters:</th><td class="field-body"><p class="first"><strong>df</strong> : pd.DataFrame</p>
</td>
</tr>
<tr class="field-even field"><th class="field-name">Returns:</th><td class="field-body"><p class="first"><strong>stat_df</strong> : pd.DataFrame</p>
<blockquote class="last">
<div><p>Dataframe containing the statistics.</p>
</div></blockquote>
</td>
</tr>
</tbody>
</table>
<p class="rubric">Notes</p>
<p>The rows in stat_df is {&#8216;num_nan&#8217;, &#8216;num_zero&#8217;, &#8216;percent_nan&#8217;,
&#8216;percent_zero&#8217;, &#8216;median&#8217;,&#8217;mean&#8217;, &#8216;standard_deviation&#8217;, &#8216;variance&#8217;}</p>
</dd></dl>

<dl class="function">
<dt id="d2o.utils.putils.to_json">
<code class="descclassname">d2o.utils.putils.</code><code class="descname">to_json</code><span class="sig-paren">(</span><em>df</em><span class="sig-paren">)</span><a class="reference internal" href="_modules/d2o/utils/putils.html#to_json"><span class="viewcode-link">[source]</span></a><a class="headerlink" href="#d2o.utils.putils.to_json" title="Permalink to this definition">¶</a></dt>
<dd><p>Writes the data frame in json format.</p>
<table class="docutils field-list" frame="void" rules="none">
<col class="field-name" />
<col class="field-body" />
<tbody valign="top">
<tr class="field-odd field"><th class="field-name">Parameters:</th><td class="field-body"><strong>df</strong> : pd.DataFrame</td>
</tr>
<tr class="field-even field"><th class="field-name">Returns:</th><td class="field-body"><strong>json_string</strong> : str</td>
</tr>
</tbody>
</table>
</dd></dl>

<dl class="function">
<dt id="d2o.utils.putils.unicode_columns">
<code class="descclassname">d2o.utils.putils.</code><code class="descname">unicode_columns</code><span class="sig-paren">(</span><em>df</em>, <em>encoding='utf-8'</em><span class="sig-paren">)</span><a class="reference internal" href="_modules/d2o/utils/putils.html#unicode_columns"><span class="viewcode-link">[source]</span></a><a class="headerlink" href="#d2o.utils.putils.unicode_columns" title="Permalink to this definition">¶</a></dt>
<dd><p>Changes encoding of columns to &#8216;encoding&#8217;.</p>
<table class="docutils field-list" frame="void" rules="none">
<col class="field-name" />
<col class="field-body" />
<tbody valign="top">
<tr class="field-odd field"><th class="field-name">Parameters:</th><td class="field-body"><p class="first"><strong>df</strong> : pd.DataFrame</p>
<p><strong>encoding</strong> : str, default &#8216;utf-8&#8217;</p>
<blockquote>
<div><p>No need to use any other encoding than utf-8, unless you have a specific purpose.</p>
</div></blockquote>
</td>
</tr>
<tr class="field-even field"><th class="field-name">Returns:</th><td class="field-body"><p class="first"><strong>unicode_columns</strong> : list</p>
<blockquote class="last">
<div><p>The new column keys in unicode encoding.</p>
</div></blockquote>
</td>
</tr>
</tbody>
</table>
<p class="rubric">Notes</p>
<p>Deprecated, used for testing.
Currently only converts a few scandinavian characters.</p>
</dd></dl>

</div>
<div class="section" id="module-d2o.utils.systools">
<span id="d2o-utils-systools-module"></span><h2>d2o.utils.systools module<a class="headerlink" href="#module-d2o.utils.systools" title="Permalink to this headline">¶</a></h2>
<dl class="function">
<dt id="d2o.utils.systools.file_exists">
<code class="descclassname">d2o.utils.systools.</code><code class="descname">file_exists</code><span class="sig-paren">(</span><em>path</em><span class="sig-paren">)</span><a class="reference internal" href="_modules/d2o/utils/systools.html#file_exists"><span class="viewcode-link">[source]</span></a><a class="headerlink" href="#d2o.utils.systools.file_exists" title="Permalink to this definition">¶</a></dt>
<dd></dd></dl>

<dl class="function">
<dt id="d2o.utils.systools.file_size">
<code class="descclassname">d2o.utils.systools.</code><code class="descname">file_size</code><span class="sig-paren">(</span><em>path</em><span class="sig-paren">)</span><a class="reference internal" href="_modules/d2o/utils/systools.html#file_size"><span class="viewcode-link">[source]</span></a><a class="headerlink" href="#d2o.utils.systools.file_size" title="Permalink to this definition">¶</a></dt>
<dd></dd></dl>

<dl class="function">
<dt id="d2o.utils.systools.files">
<code class="descclassname">d2o.utils.systools.</code><code class="descname">files</code><span class="sig-paren">(</span><em>path</em><span class="sig-paren">)</span><a class="reference internal" href="_modules/d2o/utils/systools.html#files"><span class="viewcode-link">[source]</span></a><a class="headerlink" href="#d2o.utils.systools.files" title="Permalink to this definition">¶</a></dt>
<dd></dd></dl>

<dl class="function">
<dt id="d2o.utils.systools.maindir_abspath">
<code class="descclassname">d2o.utils.systools.</code><code class="descname">maindir_abspath</code><span class="sig-paren">(</span><span class="sig-paren">)</span><a class="reference internal" href="_modules/d2o/utils/systools.html#maindir_abspath"><span class="viewcode-link">[source]</span></a><a class="headerlink" href="#d2o.utils.systools.maindir_abspath" title="Permalink to this definition">¶</a></dt>
<dd></dd></dl>

<dl class="function">
<dt id="d2o.utils.systools.maindir_realpath">
<code class="descclassname">d2o.utils.systools.</code><code class="descname">maindir_realpath</code><span class="sig-paren">(</span><span class="sig-paren">)</span><a class="reference internal" href="_modules/d2o/utils/systools.html#maindir_realpath"><span class="viewcode-link">[source]</span></a><a class="headerlink" href="#d2o.utils.systools.maindir_realpath" title="Permalink to this definition">¶</a></dt>
<dd></dd></dl>

<dl class="function">
<dt id="d2o.utils.systools.makedirs">
<code class="descclassname">d2o.utils.systools.</code><code class="descname">makedirs</code><span class="sig-paren">(</span><em>path=None</em><span class="sig-paren">)</span><a class="reference internal" href="_modules/d2o/utils/systools.html#makedirs"><span class="viewcode-link">[source]</span></a><a class="headerlink" href="#d2o.utils.systools.makedirs" title="Permalink to this definition">¶</a></dt>
<dd></dd></dl>

<dl class="function">
<dt id="d2o.utils.systools.now_string">
<code class="descclassname">d2o.utils.systools.</code><code class="descname">now_string</code><span class="sig-paren">(</span><em>date_format='%Y-%m-%dT%H:%M:%S'</em><span class="sig-paren">)</span><a class="reference internal" href="_modules/d2o/utils/systools.html#now_string"><span class="viewcode-link">[source]</span></a><a class="headerlink" href="#d2o.utils.systools.now_string" title="Permalink to this definition">¶</a></dt>
<dd></dd></dl>

<dl class="function">
<dt id="d2o.utils.systools.on_linux">
<code class="descclassname">d2o.utils.systools.</code><code class="descname">on_linux</code><span class="sig-paren">(</span><span class="sig-paren">)</span><a class="reference internal" href="_modules/d2o/utils/systools.html#on_linux"><span class="viewcode-link">[source]</span></a><a class="headerlink" href="#d2o.utils.systools.on_linux" title="Permalink to this definition">¶</a></dt>
<dd></dd></dl>

<dl class="function">
<dt id="d2o.utils.systools.on_windows">
<code class="descclassname">d2o.utils.systools.</code><code class="descname">on_windows</code><span class="sig-paren">(</span><span class="sig-paren">)</span><a class="reference internal" href="_modules/d2o/utils/systools.html#on_windows"><span class="viewcode-link">[source]</span></a><a class="headerlink" href="#d2o.utils.systools.on_windows" title="Permalink to this definition">¶</a></dt>
<dd></dd></dl>

</div>
<div class="section" id="module-d2o.utils.timeout">
<span id="d2o-utils-timeout-module"></span><h2>d2o.utils.timeout module<a class="headerlink" href="#module-d2o.utils.timeout" title="Permalink to this headline">¶</a></h2>
<dl class="exception">
<dt id="d2o.utils.timeout.TimeoutException">
<em class="property">exception </em><code class="descclassname">d2o.utils.timeout.</code><code class="descname">TimeoutException</code><a class="reference internal" href="_modules/d2o/utils/timeout.html#TimeoutException"><span class="viewcode-link">[source]</span></a><a class="headerlink" href="#d2o.utils.timeout.TimeoutException" title="Permalink to this definition">¶</a></dt>
<dd><p>Bases: <a class="reference external" href="https://docs.python.org/library/exceptions.html#exceptions.Exception" title="(in Python v2.7)"><code class="xref py py-class docutils literal"><span class="pre">exceptions.Exception</span></code></a></p>
</dd></dl>

<dl class="function">
<dt id="d2o.utils.timeout.timeout">
<code class="descclassname">d2o.utils.timeout.</code><code class="descname">timeout</code><span class="sig-paren">(</span><em>seconds=5</em>, <em>error_message='Timer expired'</em><span class="sig-paren">)</span><a class="reference internal" href="_modules/d2o/utils/timeout.html#timeout"><span class="viewcode-link">[source]</span></a><a class="headerlink" href="#d2o.utils.timeout.timeout" title="Permalink to this definition">¶</a></dt>
<dd></dd></dl>

</div>
<div class="section" id="module-d2o.utils">
<span id="module-contents"></span><h2>Module contents<a class="headerlink" href="#module-d2o.utils" title="Permalink to this headline">¶</a></h2>
</div>
</div>


           </div>
          </div>
          <footer>
  

  <hr/>

  <div role="contentinfo">
    <p>
        &copy; Copyright 2016, Chronos AS.

    </p>
  </div>
  Built with <a href="http://sphinx-doc.org/">Sphinx</a> using a <a href="https://github.com/snide/sphinx_rtd_theme">theme</a> provided by <a href="https://readthedocs.org">Read the Docs</a>. 

</footer>

        </div>
      </div>

    </section>

  </div>
  


  

    <script type="text/javascript">
        var DOCUMENTATION_OPTIONS = {
            URL_ROOT:'./',
            VERSION:'1.0',
            COLLAPSE_INDEX:false,
            FILE_SUFFIX:'.html',
            HAS_SOURCE:  true
        };
    </script>
      <script type="text/javascript" src="_static/jquery.js"></script>
      <script type="text/javascript" src="_static/underscore.js"></script>
      <script type="text/javascript" src="_static/doctools.js"></script>
      <script type="text/javascript" src="https://cdn.mathjax.org/mathjax/latest/MathJax.js?config=TeX-AMS-MML_HTMLorMML"></script>

  

  
  
    <script type="text/javascript" src="_static/js/theme.js"></script>
  

  
  
  <script type="text/javascript">
      jQuery(function () {
          SphinxRtdTheme.StickyNav.enable();
      });
  </script>
   

</body>
</html>